package TSim;

/** Class that creates a new TSimInterface and starts it.
 *
 */
public class TSimFactory
{
    private static boolean started=false;
    
    /**
     * Main train controller method.
     *
     * @param args Single-element array containing a string representation of
     * the port number of the server to connect to.
     */
    public static void main(String[] args) {
	if (args.length<1) {
	    System.err.println("Arguments: <TCP port> [-log]");
	    System.exit(1);
	} else {
	    int port;
	    try {
		port=Integer.parseInt(args[0]);
	    } catch(NumberFormatException nfe) {
		throw
		    new RuntimeException("First argument must be port number.");
	    }
	    if (args.length>=2)
		if (args[1].equals("-log"))
		    TSimStream.logging=true;
		else {
		    System.err.println("Second argument must be -log.");
		    System.exit(1);
		} 		    
	    if (started)
		throw new IllegalStateException("TSimInterface must be unique");
	    started=true;

	    final TSimInterface tsim = new TSimInterface(port);	
	    new Thread(tsim).start();
	    new Thread(new trains.Train(tsim)).start();
	}
    }
}
