package trains;

import TSim.*;

public class Train implements Runnable {
    private static final int SPEED=20;

    private static TSimInterface tsi;
    boolean forward=true;

    public Train(TSimInterface t) {
	tsi=t;
    }

    public void turn() {
	try {
	    tsi.loadUnload();
	} catch(CommandException ce) {
	    System.err.println("Failed to stop.");
	    System.exit(1);
	}

	forward=!forward;
	if (forward)
	    setSpeed(SPEED);
	else
	    setSpeed(-SPEED);
    }

    public void run() {
	setSwitch(15, 10, TSimInterface.SWITCH_RIGHT);
	setSwitch(9, 6, TSimInterface.SWITCH_RIGHT);
	setSpeed(SPEED);
	while(true) {
	    try {
		SensorEvent se=tsi.getSensor();
		if (se.getStatus()==SensorEvent.ACTIVE) {
		    switch(se.getXpos()) {
			case 3:
			    if (forward)
				turn();
			    break;
			case 5:
			    /* To keep example simple, stop this train here. */
			    setSpeed(0);
			    break;
			default:
			    if (!forward)
				turn();
		    }
		}
	    } catch (CommandException ce) {
		die(ce);
	    }
	}
    }

    private void setSpeed(int speed) {
	try {
	    tsi.setSpeed(speed);
	} catch(CommandException ce) {
	    die(ce);
	}
    }

    private void setSwitch(int x, int y, int dir) {
	try {
	    tsi.setSwitch(x, y, dir);
	} catch(CommandException ce) {
	    die(ce);
	}
    }

    private void die(CommandException ce) {
	ce.printStackTrace();
	System.err.println(ce.getMessage());
	System.exit(1);	    
    }
}
